<?xml version='1.0' encoding='UTF-8' ?>
<!--
  ~ Copyright (c) 2016 Roman Nazarenko.
  ~
  ~  This program is free software: you can redistribute it and/or modify
  ~  it under the terms of the GNU Affero General Public License as
  ~  published by the Free Software Foundation, either version 3 of
  ~  the License, or (at your option) any later version.
  ~
  ~  This program is distributed in the hope that it will be useful,
  ~  but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~  GNU General Public License for more details.
  ~
  ~  You should have received a copy of the GNU General Public License
  ~  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	  xmlns:h="http://xmlns.jcp.org/jsf/html"
	  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	  xmlns:f="http://xmlns.jcp.org/jsf/core">

<h:head>
	<ui:include src="/WEB-INF/jsf/include/title.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/imports.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/init.xhtml"/>
</h:head>
<h:outputScript>
	$(function () {
		jsf.ajax.addOnEvent(function (event) {
			if (event.status === 'success') {
				if ($(event.source).attr('id') === 'addBlogEntryFormId:createBlogEntryButtonId' &amp;&amp; !$('#addBlogEntryFormId').hasClass('error')) {
					$('#addBlogEntryModalId').modal('hide');
				}
			}
		})
	});
</h:outputScript>
<h:body styleClass="pushable">
	<div class="pusher">
		<div class="ui container framed">
			<ui:include src="/WEB-INF/jsf/include/header.xhtml"/>

			<div class="ui centered two columns footer-margin grid">
				<div class="ui thirteen wide column">
					<div class="ui raised segment">
						<h2>Edit blog</h2>
						<button class="ui primary image button"
								onclick="$('#addBlogEntryModalId').modal('show');">
							<i class="plus icon"></i>
							Add entry
						</button>
						<br/>
						<br/>
						<h:form id="manageArticlesFormId"
								styleClass="ui ${errorUtils.formClass(component)} form">
							<div class="ui error message">
								<div class="header">Error:</div>
								<h:messages showDetail="true" showSummary="false"/>
							</div>
							<div class="field">
								<div class="ui middle aligned celled animated list">
									<ui:repeat value="${blogEditBean.articles}" var="article">
										<div class="item">
											<div class="right floated content">
												<h:link styleClass="ui button" outcome="/admin/post.xhtml">
													Edit
													<f:param name="${navigationParameterUtils.blogPostNameParameter}" value="${article.internalTitle}"/>
												</h:link>
												<h:commandButton styleClass="ui small red button"
																 value="Delete"
																 action="#{blogEditBean.deleteArticle(article.id)}"
																 onclick="return confirm('Are you sure want to delete article ${article.title}');">
													<f:ajax render=":manageArticlesFormId"/>
												</h:commandButton>
											</div>
											<div class="content">
												<h3 class="header">
													<h:link outcome="/blog/post.xhtml">
														${article.title}
														<f:param name="${navigationParameterUtils.blogPostNameParameter}"
																 value="${article.internalTitle}"/>
													</h:link>
												</h3>
												<div class="description">
													Created
													<span class="local-date-time">${article.created.toInstant().toEpochMilli()}</span>
													|
													<i class="${article.published ? 'green check' : 'red remove'} icon"></i>
													${article.published ? 'Published' : 'Not published'}
												</div>
											</div>
										</div>
									</ui:repeat>
								</div>
							</div>
						</h:form>
					</div>
				</div>
			</div>
		</div>

		<div id="addBlogEntryModalId" class="ui small modal">
			<i class="close icon"></i>
			<div class="header">Add entry</div>
			<div class="content">
				<h:form id="addBlogEntryFormId"
						styleClass="ui ${errorUtils.formClass(component)} form">
					<div class="field">
						<label>Blog entry title</label>
						<h:inputText value="#{newArticleTitle}" validatorMessage="A title must be presented">
							<f:passThroughAttribute name="placeholder" value="Title"/>
							<f:validateRequired/>
						</h:inputText>
					</div>
					<div class="field">
						<label>Short name for navigation</label>
						<h:inputText value="#{newArticleInternalTitle}"
									 binding="#{articleShortNameInput}"
									 validatorMessage="A short name must be presented, contain lowercase letters, numbers or dashes and be less that 255 chars long">
							<f:passThroughAttribute name="placeholder" value="(letters, numbers, dashes)"/>
							<f:validateRequired/>
							<f:validateRegex pattern="[\-a-z\d]+"/>
						</h:inputText>
					</div>
					<div class="ui error message">
						<div class="header">Error:</div>
						<h:messages showDetail="true" showSummary="false"/>
					</div>
					<h:commandButton id="createBlogEntryButtonId"
									 styleClass="ui positive button"
									 value="Create"
									 action="#{blogEditBean.createArticle(newArticleTitle, newArticleInternalTitle, articleShortNameInput)}">
						<f:ajax execute="@form" render=":addBlogEntryFormId :manageArticlesFormId"/>
					</h:commandButton>
					<div class="ui deny button" onclick="$('#addBlogEntryModalId').modal('hide')">
						Cancel
					</div>
				</h:form>
			</div>
		</div>
		<ui:include src="/WEB-INF/jsf/include/footer.xhtml"/>
	</div>
</h:body>
</html>

